import { createMuiTheme } from "@material-ui/core/styles";

export const theme = createMuiTheme({
  overrides: {
      MuiTooltip: {
          tooltip: {
            fontSize: 15,
            backgroundColor: "#707070ff",
          },
      },
  },
  props: { MuiWithWidth: { initialWidth: 'lg' } },
  palette: {
    primary: {
      main: "#0099dc"
    },
    secondary: {
      main: "#0d598e"
    },
    status: {
      ok: '#4caf50',
      fail: '#aa2e25',
      neutral: '#000',
      progress: '#ffc107',
    },
  },
  typography: {
    fontFamily:[
      '-apple-system',
      'BlinkMacSystemFont',
      '"Segoe UI"',
      'Roboto',
      '"Helvetica Neue"',
      'Arial',
      'Noto Sans',
      'sans-serif',
      '"Apple Color Emoji"',
      '"Segoe UI Emoji"',
      '"Segoe UI Symbol"',
      '"Noto Color Emoji"',
    ].join(','),
    h1: {
      fontFamily: 'Titillium Web, sans-serif',
      fontSize: 24,
    },
    h2: {
      fontFamily: [
        "Segoe UI",
        'Roboto',
        'Noto Sans',
      ].join(','),
      fontSize: 34,
      fontWeight: 600,
    },
    h5: {
      fontFamily: [
        "Segoe UI",
        'Roboto',
        'Noto Sans',
      ].join(','),
      fontSize: 16,
      fontWeight: 600,
    },
    overline: {
      fontFamily: [
        "Segoe UI",
        'Roboto',
        'Noto Sans',
      ].join(','),
      fontSize: 16,
      fontWeight: 600,
    },
  },
});

