import React, {useContext} from 'react';
import { userContext } from "../../api/SwaggerApi";
import AccessDenied from "./AccessDenied";

const checkPermissions = (userRoles, allowedRoles) => {
  if (allowedRoles.length === 0) {
    return true;
  }

  return userRoles?.some(role =>
    allowedRoles.includes(role)
  );
};

export default function AccessControl({ allowedRoles, children, renderNoAccess}) {
  const { userRoles } = useContext(userContext);

  const permitted = checkPermissions(userRoles, allowedRoles);
  if (permitted) {
    return children;
  }
  if (!renderNoAccess) {
    return(
      <AccessDenied/>
    );
  }
  return renderNoAccess();
}