import { useEffect, useContext } from "react";
import { useRenewToken, userContext } from "../../api/SwaggerApi";

export default function TokenRenew() {
  const { user, getUserRoles } = useContext(userContext);
  const renewToken = useRenewToken();

  useEffect(() => {
    const interval = setInterval(async () => {
      if(user) {
        await renewToken();
        getUserRoles();
      }
    }, `${window.TOKEN_RENEW_INTERVAL}`);
    return () => clearInterval(interval);
  }, [renewToken, user, getUserRoles]);
    
  return null;
}