import React from 'react';
import { LokiPanel } from './LokiPanel';
import { Dialog, DialogContent, DialogTitle, makeStyles } from "@material-ui/core";

const useStyles = makeStyles((theme) => ({
    title: {
       backgroundColor: "#0099dc",
       color: "#FFFFFF",
     }
 }));

export function LokiDialog({ open, setOpen, host, iocName, isSyslog, isDeployed }) {

    const classes = useStyles();

    const handleClose = () => {
        setOpen(false);
    };

    const dialogTitle = () => {
        return isSyslog ? 'Syslog' : 'ProcServ log';
    }

    return (
        <Dialog open={open} onClose={handleClose} fullWidth={true} maxWidth='xl'>
            <DialogTitle id="log-dialog-title" className={classes.title}>{dialogTitle()}</DialogTitle>
            <DialogContent>
                <LokiPanel host={host} iocName={iocName} isSyslog={isSyslog} isDeployed={isDeployed} shownInDialog={true}/>
            </DialogContent>
        </Dialog>
    );
}