import React, { useState, useEffect } from 'react';
import { LinearProgress, Typography, Container } from '@material-ui/core';
import { useDeploymentJob } from '../../api/SwaggerApi';
import { ConsoleOutput } from "../common/Console/ConsoleOutput";

export function DeploymentJobOutput({ awxJobId, update, shownInDialog }) {
  const [deploymentJob, getDeploymentJob] = useDeploymentJob(awxJobId);
  const [oneMoreIteration, setOneMoreIteration] = useState(true);

  useEffect(() => {
    const interval = setInterval(() => {
      if (update) {
        getDeploymentJob();
      }

      if(!update && oneMoreIteration) {
        getDeploymentJob();
        setOneMoreIteration(false);
      }
    }, 5000);
    return () => clearInterval(interval);
  }, [update, oneMoreIteration, getDeploymentJob]);

  const dataReady = () => {
    return deploymentJob?.started;
  }

  return(
    <Container maxWidth='xl'>
      {deploymentJob?.started ?
      <div style={{
          width: "100%",
        }}>
        <div style={{
            display: "flex",
            alignItems: "center"
          }}>
          <Typography variant="overline">DURATION: </Typography>
          <Typography style={{
              marginLeft: "6px",
            }}>
            {deploymentJob?.elapsed.toFixed(0)} s
          </Typography>
        </div>
        <ConsoleOutput 
          html={deploymentJob.stdout}
          dataReady={dataReady}
          shownInDialog={shownInDialog}
        />
      </div>
      : <div style={{ width: "100%" }}><LinearProgress color="primary" /></div>
      }
    </Container>
    )
}