import React from 'react';
import { DeploymentJobOutput } from './DeploymentJobOutput';
import { Dialog, DialogContent, DialogTitle, makeStyles } from "@material-ui/core";

const useStyles = makeStyles((theme) => ({
    title: {
        backgroundColor: "#0099dc",
        color: "#FFFFFF",
    }
}));

export function DeploymentLogDialog({ open, setOpen, awxJobId, updateOutput }) {

    const classes = useStyles();

    const handleClose = () => {
        setOpen(false);
    };

    return (
        <Dialog open={open} onClose={handleClose} fullWidth={true} maxWidth='xl'>
            <DialogTitle id="log-dialog-title" className={classes.title}>AWX job details</DialogTitle>
            <DialogContent>
                <DeploymentJobOutput awxJobId={awxJobId} update={updateOutput} shownInDialog={true}/>
            </DialogContent>
        </Dialog>
    );
}