import React from 'react';
import { RootContainer } from "../../components/common/Container/RootContainer";
import AccessControl from "../../components/auth/AccessControl";
import { IOCDetailsView } from "./IOCDetailsView";
import { useGlobalAppBar } from '../../components/navigation/GlobalAppBar/GlobalAppBar';

export function IOCDetailsAccessControl({ match }) {
  const id = parseInt(match.params.id);
  useGlobalAppBar("IOC Details");

  return (
    <RootContainer>
      <AccessControl allowedRoles={["DeploymentToolAdmin", "DeploymentToolIntegrator"]}>
        <IOCDetailsView id={id}/>
      </AccessControl>
    </RootContainer>
  );
}