import React from 'react';
import { RootContainer } from "../../components/common/Container/RootContainer";
import AccessControl from "../../components/auth/AccessControl";
import { HostDetailsView } from "./HostDetailsView";
import { useGlobalAppBar } from '../../components/navigation/GlobalAppBar/GlobalAppBar';

export function HostDetailsAccessControl({ match }) {
  const id = parseInt(match.params.id);
  useGlobalAppBar("Host Details");

  return (
    <RootContainer data-testid="host-details-container">
      <AccessControl allowedRoles={["DeploymentToolAdmin", "DeploymentToolIntegrator"]}>
        <HostDetailsView id={id}/>
      </AccessControl>
    </RootContainer>
  );
}